/**************************************
 * Steven Stanek
 * January 13, 2001
 * YZiForm Image Format (yziform.h)
 * Version 0.0.1c
 *
 * Introductory Note: This is the first
 * implementation of the YZiForm image
 * format for the YZ Windowing System.
 **************************************/
 
#ifndef yziform_H
#define yziform_H

//Uniform Transparency Stuff
#define  TRANS_STR	"+"
#define	 TRANS_A	65535


#include <yz/window.h>
#include <yz/draw.h>
#include <yz/image.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

typedef struct yzImageData *yzImage;

//Opens an image file
yzImage openImageFile(FILE *toOpen);

//Draws image at coords, uses fastdraw if enabled
void drawImage(yzImage toDraw, int x, int y);

//Converts image to a 2d array of color_t [y][x]
color_t** toColors(yzImage toConvert);

//Returns a color_t * of the color at the coords, NULL if coords are wrong
//NOTE: Image Starts at x = 0, y = 0
color_t *getColorAt(yzImage aImage, int x, int y);

//Deletes all info associated with Image
void destroyImage(yzImage toKill);

//Return an Image's width
int getImageWidth(yzImage aImage);

//Returns an Image's height
int getImageHeight(yzImage aImage);

//Sets an Image in Fast Draw mode so that it draws more quickly
//Warning: Consumes alot of memory, on failure fastdraw is not set
//Warning: Doesn't use transparency
void enableFastDraw(yzImage aImage);

//Returns the void * which can be passed into yzDisplayBits() if fastDraw
//is enabled. It returns null if fastDraw is not enabled.
//This function is usually not needed because drawImage() automatically
//draws with fastDraw if fastDraw is enabled. It may be useful for buffering
//on a pre-screen buffer
void* getFastDrawArray(yzImage aImage);


#endif